//---------------------------------------------------------------------------
//Program Vektorizator
//Slou k oprav, rozpoznn a stenmu pospojovn vrstevnic 
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
: TForm(Owner)
{
  al=0;    // smrovka pi thlen1
}
//---------------------------------------------------------------------------
//Tlatko vektorizace
//Spout proces vektorizace
void __fastcall TForm1::Button10Click(TObject *Sender)
{
  //zablokovn tlatek, kter se po vektorizai ji nemou pout
  Filtr1->Enabled=false;
  Button2->Enabled=false;
  Button12->Enabled=false;
  Button13->Enabled=false;
  Button10->Enabled=false;
  //odblokovn pkazu Uloit v nabdce Soubor
  Uloit1->Enabled=true;
  //deklaraci promnch
  #ifdef _DEBUG
  int poci1=0;
  #endif
  int j;
  int i=0;
  //proces vektorizace zan hlednm ar(vrstevnic)
  //ry se nejdve hledaj na okrajch obrzku
  // hledn zan zleva
  //prohledv se 5 pixel od kraje
  for(i=0;i<5;i++)
    for( j=0;j<mapa->vyska-5;j++)
  {
    //Test potu ernch pixel v dan oblasti
    if (test(i,j,mapa->sirka,mapa->vyska))
    {
      //Test potu ernch pixel v dan oblasti o krok dl
      //najde sted ry
      if(testpoc(i,j,mapa->sirka,mapa->vyska)<testpoc(i,j+1,mapa->sirka,mapa->vyska))
        continue;

      go(i,j,4,mapa->sirka,mapa->vyska);  //spout vlastn proces vektorizace
      #ifdef _DEBUG
      poci1++;
      if(poci1==10000)return; //ochrana pi ladn
      #endif
    }
  }
  // hledn ar zprava, proces je stejn jako v pedelm cyklu
  for(i=mapa->sirka-5;i>mapa->sirka-10;i--)
    for( j=0;j<mapa->vyska-5;j++)
  {
    if (test(i,j,mapa->sirka,mapa->vyska)==true)
    {
      if(testpoc(i,j,mapa->sirka,mapa->vyska)<testpoc(i,j+1,mapa->sirka,mapa->vyska))
        continue;
      go(i,j,2,mapa->sirka,mapa->vyska);
      #ifdef _DEBUG
      poci1++;
      if(poci1==10000)return;
      #endif
    }
  }
  //hledn ar ze zdola, proces je stejn jako v pedelm cyklu
  for( j= mapa->vyska-5 ;j>mapa->vyska-10;j--)
    for( i=0;i<mapa->sirka-5;i++)
  {
    if (test(i,j,mapa->sirka,mapa->vyska)==true)
    {
      if(testpoc(i,j,mapa->sirka,mapa->vyska)<testpoc(i+1,j,mapa->sirka,mapa->vyska))
        continue;
      go(i,j,1,mapa->sirka,mapa->vyska);
      #ifdef _DEBUG
      poci1++;
      if(poci1==10000)return;
      #endif
    }
  }
  //nastaven progressbaru
  ProgressBar1->Max=mapa->vyska/2;
  ProgressBar1->Position=0;
  // heldn ar ze zhora a dale po celm obrzku
  for( j=0;j<mapa->vyska-5;j=j+2)
  {
    ProgressBar1->Position++;
    for( i=0;i<mapa->sirka-5;i=i+2)
    {
      if (test(i,j,mapa->sirka,mapa->vyska)==true)
      {
        if(testpoc(i,j,mapa->sirka,mapa->vyska)<testpoc(i+2,j,mapa->sirka,mapa->vyska))
          continue;
        go(i,j,3,mapa->sirka,mapa->vyska);
        #ifdef _DEBUG
        poci1++;
        if(poci1==2000000)
        {
          ShowMessage("Pli mnoho ar");
          return;
        }
        #endif
      }
      a[i][j]=1;
    }
  }
  ShowMessage("Hotovo");
  Prekreslit();
  Button18->Enabled=true;
}
//---------------------------------------------------------------------------
//Tlatko thlen auto
//spout funkci zethlen ar 4 kroky najednou
void __fastcall TForm1::Button12Click(TObject *Sender)
{
  stihleni_auto();
}
//---------------------------------------------------------------------------
//Tlatko thlen
//spout funkci thlen
void __fastcall TForm1::Button13Click(TObject *Sender)
{
  stihleni_1();
}
//---------------------------------------------------------------------------
//Tlatko Pospojovat
//funkce se sna pospojovat peruin vrstevnice
void __fastcall TForm1::Button18Click(TObject *Sender)
{
  //deklarace promnnch
  float uhel,uhel1; //s, s1
  float del,del1,del2;
  int na_konec;     //co
  int i2=-1;
  int pocet;
  //zablokovn tlatka Pospojovat
  Button18->Enabled=false;
  //Alokace pamti pro parametry konc ar
  konec.Alloc(mapa->get_pocetcar()*2);
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    konec.bod(i,mapa->get_cara(i));
  }
  //Nastaven progressbaru
  ProgressBar1->Max=konec.get_cout()*3;
  ProgressBar1->Position=0;

  //funkce procht vechny konce ar a hled k nim nejbli
  //konce ar pro spojen 
  for(int k=0;k<3;k++)
    for(int i=0;i<konec.get_cout();i++)
  {
    ProgressBar1->StepIt();
    del=1000000;
    for(int j=i+1;j<konec.get_cout();j++)
    {
      //vzdlenost konc ar
      del1=konec.get_bod(i).Vzdalenost(konec.get_bod(j));
      //vzdlenost protaench konc o polovinu jejich vzdlenosti
      del2=konec.get_bods(i).Trans(del1/2).Vzdalenost(konec.get_bods(j).Trans(del1/2));
      if(del1<del2) continue;
      del1=del1+del2;
      //hel spojovanch ar
      uhel= (fabs(fabs( konec.get_smer(i)-konec.get_smer(j))-M_PI)*200/M_PI);
      if(del1<del)
      {
        del=del1;
        na_konec=j;
        uhel1=uhel;
      }
    }
    //kritrium kdy mj bt konce spojeny
    if((del<45 && uhel1<70.0) ||(del<80 && uhel1<15.0) )
    {
      if(konec.get_spoj(na_konec)==-1 || konec.get_spoj(na_konec)==-3)
      {
        konec.Spoj(i,na_konec,del);
      }
      else
      {
        if(del*1.2< konec.get_del(na_konec))
        {
          konec.Spoj_plus(i,na_konec,del);
        }
      }
    }
  }

  //hledn ry ve vtm okol
  for(int k=0;k<3;k++)
    for(int i=0;i<konec.get_cout();i++)
  {
    ProgressBar1->StepIt();
    del=1000000;
    if( konec.get_spoj(i)==-3)continue;
    for(int j=0;j<konec.get_cout();j++)
    {
      if(i!=j &&  konec.get_spoj(j)!=-3)
      {
        del1=konec.get_bod(i).Vzdalenost(konec.get_bod(j));
        del2=konec.get_bods(i).Trans(del1).Vzdalenost(konec.get_bods(j));
        if(del1<del2 ) continue;
        del1=del1+1.0*del2;
        uhel= (fabs(fabs( konec.get_smer(i)-konec.get_smer(j))-M_PI)*200/M_PI);
        if(uhel>150)
          del1=del1*uhel/75.0;
        if(del1<del)
        {
          del=del1;
          na_konec=j;
          uhel1=uhel;
        }
      }
    }
    //kritrium spojen
    if(del<500 )
    {
      if(konec.get_spoj(na_konec)==-1 && konec.get_spoj(i)==-1)
      {
        konec.Spoj(i,na_konec,del);
      }
      else
      {
        if(del*1.1< konec.get_del(na_konec))
        {
          konec.Spoj_plus(i,na_konec,del);
        }
      }
    }
  }

  //  Hledn ar na okraji mapy pro oznaen konce ry jako okraje
  int pr;
  for(int i=0;i<konec.get_cout();i++)
  {
    ProgressBar1->StepIt();
    pr=0;
    if(konec.get_spoj(i)==-1)
    {
      Hbod2D A=konec[i].Trans(400,konec.get_smer(i));
      if(A.get_x()<0 || A.get_y()<0 || A.get_x()>mapa->sirka || A.get_y()>mapa->vyska)
      {
        for(int j=0;j<konec.get_cout();j++)
        {
          if(konec.get_spoj(j)>=0)
            pr=  intersect(A,konec.get_bods(i),konec.get_bods(j),konec.get_bods(konec.get_spoj(j)) );
          if(pr==1)
            break;
        }
        if(pr!=1)
        {
          for(int w=0;w<mapa->get_pocetcar();w++)
          {
            for(int j=1;j<mapa->get_pocetbodu_nacare(w)-1;j++)
            {
              pr=  intersect(A,konec.get_bods(i),mapa->get_bod(w,j),mapa->get_bod(w,j+1));
              if(pr==1)
              {
                break;
              }
            }
            if(pr==1)break;
          }
          if(pr!=1)     konec.Spoj(i);
        }
      }
    }
  }
  //hledn ry ve vtm okol
  for(int i=0;i<konec.get_cout();i++)
  {
    if( konec.get_spoj(i)>=0)continue;
    ProgressBar1->StepIt();
    del=1000000;
    for(int j=0;j<konec.get_cout();j++)
    {
      if( konec.get_spoj(j)>=0)continue;
      if(i!=j )
      {
        del1=konec.get_bod(i).Vzdalenost(konec.get_bod(j));
        del2=konec.get_bods(i).Trans(del1/2).Vzdalenost(konec.get_bods(j).Trans(del1/2));
        if(del1<del2) continue;
        del1=del1+del2;
        uhel= (fabs(fabs( konec.get_smer(i)-konec.get_smer(j))-M_PI)*200/M_PI);
        if(del1<del)
        {
          del=del1;
          na_konec=j;
          uhel1=uhel;
        }
      }
    }
    if(del!=1000000)
      if(konec.get_spoj(na_konec)!=konec.get_spoj(i) && del<=30 )
    {
      if(konec.get_spoj(na_konec)==-1 ||konec.get_spoj(na_konec)==-3)
      {
        konec.Spoj(i,na_konec,del);
      }
      else
      {
        if(del*1.2<konec.get_del(na_konec))
        {
          konec.Spoj_plus(i,na_konec,del);
        }
      }
    }
  }
  //vpoet potu nespojench konc
  i2=-1;
  pocet=0;
  do
  {
    i2++;
    if(konec.get_spoj(i2)==-1)pocet++;
  }
  while(konec.get_cout()  >i2 );
  ShowMessage("Poet chyb "+(String)pocet);
  Prekreslit();

}
//---------------------------------------------------------------------------
//tlatko Oprava
//spout funkci pro zkladn opravu obrzku
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Oprava();
}
//---------------------------------------------------------------------------
//funkce pro obnuvu obrzku na obrazovce
void TForm1::Prekreslit()
{
  //nastaven bitov reprezentace barev
  Form1->Image1->Picture->Bitmap->PixelFormat= pf24bit ;
  Byte *ptr;
  //pekreslen obrzku pomoc pmho  pstupu do pamti,
  //kter reprezentuje obrzek
  for(int j=0;j<Form1->Image1->Height;j++)
  {
    ptr = (Byte *)Form1->Image1->Picture->Bitmap->ScanLine[j];
    for(int i=0;i<Form1->Image1->Width;i++)
    {
      ptr[i*3+1]=ptr[i*3+2]= ptr[i*3] = ((bool)a[i+Form1->ScrollBar1->Position][Form1->ScrollBar2->Position+j])*0xff;
    }
  }
  //pekreslen obrzku
  Form1->Image1->Canvas->Draw(0,0,Form1->Image1->Picture->Bitmap);

  //vykreslen zvektorizovanch vrstevnic
  Form1->Image1->Canvas->Pen->Color=(TColor)0xff;
  Form1->Image1->Canvas->Font->Color=(TColor)0xff;
  Form1->Image1->Canvas->Font->Size=10;
  Form1->Image1->Canvas->Brush->Style=bsClear        ;
  for(int i=0;i<mapa->get_pocetcar() ;i++)
  {
    Form1->Image1->Canvas->TextOut(mapa->get_bod(i,1).get_x()-Form1->ScrollBar1->Position,mapa->get_bod(i,1).get_y()-Form1->ScrollBar2->Position,i);
    Form1->Image1->Canvas->MoveTo(mapa->get_bod(i,0).get_x()-Form1->ScrollBar1->Position,mapa->get_bod(i,0).get_y()-Form1->ScrollBar2->Position);
    for(int j=1;j<mapa->get_pocetbodu_nacare(i);j++)
    {
      Form1->Image1->Canvas->LineTo(mapa->get_bod(i,j).get_x()-Form1->ScrollBar1->Position,mapa->get_bod(i,j).get_y()-Form1->ScrollBar2->Position);
    }
  }
  //vykreslen pospojovanch konc
  Form1->Image1->Canvas->Font->Color=(TColor)0xffff00 ;
  Form1->Image1->Canvas->Pen->Color=(TColor)0xffff00;
  for(int q=0;q<konec.get_cout();q++)
  {
    if(konec.get_spoj(q)>=0 )
    {
      //   Image2->Canvas->TextOut(konec.konec[q].x ,konec.konec[q].y,q);
      Form1->Image1->Canvas->MoveTo(konec[q].get_x()-Form1->ScrollBar1->Position, konec[q].get_y()-Form1->ScrollBar2->Position);
      Form1->Image1->Canvas->LineTo(konec[konec.get_spoj(q)].get_x()-Form1->ScrollBar1->Position,konec[konec.get_spoj(q)].get_y()-Form1->ScrollBar2->Position);
    }
  }
}
//---------------------------------------------------------------------------
//funkce obsluhujc udlost pouit vodorovnho scrollbaru
//pekresl posunut obrzek
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
  Prekreslit();
}
//---------------------------------------------------------------------------
//funkce obsluhujc udlost pouit svislho scrollbaru
//pekresl posunut obrzek
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
  Prekreslit();
}
//---------------------------------------------------------------------------
//pkaz otevt nabdka soubor
//otvr obrzek uren k vektorizaci
void __fastcall TForm1::Otevt1Click(TObject *Sender)
{
  if(OpenDialog1->Execute())//sputn dialogu pro vybrn souboru
  {
    //smazn a dynamick vytvoen promnn mapa
    delete mapa;
    mapa=new Hmapa();
    HANDLE hAppend;
    DWORD del;
    //oteven souboru pro ten
    hAppend = CreateFile(OpenDialog1->FileName.c_str(),
                         GENERIC_READ   ,
                         0,
                         NULL,
                         OPEN_EXISTING      ,
                         FILE_ATTRIBUTE_NORMAL,
                         NULL);
    //peten rozmr obrzku
    ReadFile(hAppend, &mapa->vyska, sizeof(int), &del, NULL) ;
    ReadFile(hAppend, &mapa->sirka, sizeof(int), &del, NULL) ;
   
    a =new bool* [mapa->sirka];   //alokace pamti pro obrzek
    for(int l=0;l<mapa->sirka;l++)
    {
      a[l] = new bool [mapa->vyska];
    }
    //alokace pamti pro doasn uloen obrzku ve vstupnm formtu
    char* tmp =new char [mapa->vyska*mapa->sirka/8+1];
    //naten obrzku do pamti
    ReadFile(hAppend, tmp,  mapa->vyska*mapa->sirka/8+1, &del, NULL) ;
    CloseHandle(hAppend); //zaven souboru

    //nastaven velikosti obrzku zobratenho na obrazovce
    Image1->Width=200;
    Image1->Height=200;
    if(Image1->Width>mapa->sirka)Image1->Picture->Bitmap->Width=mapa->sirka;
    else  Image1->Picture->Bitmap->Width=Image1->Width;
    if(Image1->Height>mapa->vyska)Image1->Picture->Bitmap->Height=mapa->vyska;
    else Image1->Picture->Bitmap->Height=Image1->Height ;
    char *ptr;
    int i,j,ij;
    ProgressBar1->Position=0;  //nastaven progressbaru
    ProgressBar1->Max=mapa->vyska;
    int poc,poc1;
    //konverze obrzku ze vstupnho formtu do formtu pouvanho
    //pro vektorizaci
    for(j=0;j<mapa->vyska;j++)
    {
      ProgressBar1->StepIt();
      ij=j*mapa->sirka;
      for(i=0;i<mapa->sirka;i++)
      {
        a[i][j] =tmp[(i+ij)/8] & 1<<(i+ij)%8;
      }
    }
    delete tmp;//smazn doasn pamti
    //nastaven velikosti obrzku a posuvnku
    if (Image1->Width>mapa->sirka)Image1->Width=mapa->sirka;
    if (Image1->Height>mapa->vyska)Image1->Height=mapa->vyska;
    ScrollBar1->Max=mapa->sirka-Image1->Width;
    ScrollBar2->Max=mapa->vyska-Image1->Height;
    //aktivovn tlatek
    ScrollBar2->Enabled=true;
    ScrollBar1->Enabled=true;
    Filtr1->Enabled=true;
    Button2->Enabled=true;
    Button12->Enabled=true;
    Button13->Enabled=true;
    Button10->Enabled=true;
    //zmna velikosti okna formule
    FormResize(Form1);
  }
}
//---------------------------------------------------------------------------
//nabda Filtr pkaz Oprava
//spout funkci pro zkladn opravu obrzku
void __fastcall TForm1::Oprava1Click(TObject *Sender)
{
  Oprava();
}
//---------------------------------------------------------------------------
//Funkce pro zjitn sprvn velikosti okna aplikace
void TForm1::Format()
{
  int w,h;
  w=Width;
  h=Height;
  if(Width>mapa->sirka+110)
  {
    w=mapa->sirka+110;
  }
  else w=Width;
  if(Height>mapa->vyska+80)
  {

    h=mapa->vyska+80;
  }
  else h=Height;
  Image1->Width=w-110;
  ScrollBar2->Left=w-110;
  ScrollBar2->Height=h-80;
  Image1->Height=h-80;
  Image1->Picture->Bitmap->Height=h-80;
  Image1->Picture->Bitmap->Width=w-110;
  ScrollBar1->Top=h-80;
  ScrollBar1->Width =w-110;
  Button2->Left=Width-87;
  Button12->Left=Width-87;
  Button13->Left=Width-87;
  Button10->Left=Width-87;
  Button18->Left=Width-87;
  ProgressBar1->Top=Height-57;
  ProgressBar1->Width=Width-10;
  ScrollBar1->Max=mapa->sirka-Image1->Width;
  ScrollBar2->Max=mapa->vyska-Image1->Height;
  if(mapa->sirka<=Image1->Width) ScrollBar1->Visible=false;
  else ScrollBar1->Visible=true;
  if(mapa->vyska<=Image1->Height) ScrollBar2->Visible=false;
  else ScrollBar2->Visible=true;
}
void __fastcall TForm1::Uloit1Click(TObject *Sender)
{
  if(SaveDialog1->Execute())
  {
    ofstream car(SaveDialog1->FileName.c_str()     );
    mapa->Zapis_car(car);
    ofstream sou1((SaveDialog1->FileName.SubString(1,SaveDialog1->FileName.LastDelimiter(".") )+"kon").c_str());
    for(int i=0;i<konec.get_cout();i++)
    {
      sou1<<i<<"\t"<<konec.get_bods(i);
    }
    sou1.close();
  }
}
//---------------------------------------------------------------------------
//funkce mnc velikost okna aplikace
void __fastcall TForm1::FormResize(TObject *Sender)
{
  if(Width<200)
  {
    Width=200;
    return;
  }
  if(Height<220)
  {
    Height=220;
    return;
  }
  if(Width>mapa->sirka+110 && Width>200)
  {
    if(mapa->sirka+110>200)Width=mapa->sirka+110;
    else Width=200;
    return;
  }
  if(Height>mapa->vyska+80 && Height>220)
  {
    if(mapa->vyska+80>220)Height=mapa->vyska+80;
    else  Height=220;
    return;
  }
  Format();
  Prekreslit();
}
//---------------------------------------------------------------------------
//Funkce pro zkladn opravu obrzku
//dopln ern bod na msto, kter m ze 3 stran souseda ernho
void TForm1::Oprava()
{
  int k;
  ProgressBar1->Max=mapa->sirka;
  ProgressBar1->Position=0;
  for(int i=1;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(int j=1;j<mapa->vyska-1;j++)
    {
      if( !a[i][j]) {continue;}
        k=0;
      k=a[i-1][j]+a[i+1][j]+a[i][j-1]+a[i][j+1];  //bl barva =1
      if(k<2)a[i][j]=false;                       //ern barva =0
    }
  }
  Prekreslit();
}
//---------------------------------------------------------------------------
//nabdka Filtr pkaz thlen auto
//spout funkci zethlen ar 4 kroky najednou
void __fastcall TForm1::thlen1Click(TObject *Sender)
{
  stihleni_auto();
}
//---------------------------------------------------------------------------
//funkce kter mae okraje ar, im smate tenk ry
//provn se ze ty stran
//pouv dva postupy
//prochz body jestlie jeho soused je bl zmn se bod na bl (theln)
//prochz body jestlie jeho dva protj soused jsou bl zmn bod na bl (mazn)
void TForm1::stihleni_auto()
{
  //alokace pamti pro doasn uloen obrzku
  int i,j;
  bool** a1 =new bool* [mapa->sirka];
  for(int l=0;l<mapa->sirka;l++)
  {
    a1[l] = new bool [mapa->vyska];
    memcpy(&a1[l][0],&a[l][0],mapa->vyska*sizeof(a[0][0]));
  }
  //vlastn thlen
  //thlen na okraji
  for(j=1;j<mapa->vyska-1;j++)
  {
//    a[0][j]=stihleni(a1[0][j-1],a1[0][j]);
    a[0][j]=stihleni(a1[0][j-1],a1[0][j]);
//    a[mapa->sirka-1][j]=stihleni(a1[mapa->sirka-1][j+1],a1[mapa->sirka-1][j]);
    a[mapa->sirka-1][j]=stihleni(a1[mapa->sirka-1][j+1],a1[mapa->sirka-1][j]);
  }
  for(i=1;i<mapa->sirka-1;i++)
  {
//    a[i][0]=stihleni(a1[i-1][0],a1[i][0]);
    a[i][0]=stihleni(a1[i-1][0],a1[i][0]);
//    a[i][mapa->vyska-1]=stihleni(a1[i+1][mapa->vyska-1],a1[i][mapa->vyska-1]);
    a[i][mapa->vyska-1]=stihleni(a1[i+1][mapa->vyska-1],a1[i][mapa->vyska-1]);
  }
  ProgressBar1->Max=mapa->sirka*9; //nastaven progressbaru
  ProgressBar1->Position=0;
  //theln zhora
  for(i=0;i<mapa->sirka;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska;j++)
    {
      if( a[i][j])
      {
        a1[i][j]=true;
        continue;
      }
      a1[i][j]=stihleni(a[i][j-1],a[i][j]);
    }
  }
  //mazn
  for(i=0;i<mapa->sirka;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska-1;j++)
    {
      if( a1[i][j]){ a[i][j]=true;continue;}
        a[i][j]=stihleni1(a1[i][j-1],a1[i][j],a1[i][j+1]);
    }
  }
  //thlen  zleva
  for(int i=1;i<mapa->sirka;i++)
  {
    ProgressBar1->Position++;
    for(j=0;j<mapa->vyska;j++)
    {
      if( a[i][j]){ a1[i][j]=true;continue;}
        a1[i][j]=stihleni(a[i-1][j],a[i][j]);
    }
  }
  //mazn
  for(int i=1;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(j=0;j<mapa->vyska;j++)
    {
      if( a1[i][j]){ a[i][j]=1;continue;}
        a[i][j]=stihleni1(a1[i-1][j],a1[i][j],a1[i+1][j]);
    }
  }
  //thlen zezdola
  for(int i=0;i<mapa->sirka;i++)
  {
    ProgressBar1->Position++;
    for(j=0;j<mapa->vyska-1;j++)
    {
      if( a[i][j]){ a1[i][j]=1;continue;}
        a1[i][j]=stihleni(a[i][j+1],a[i][j]);
    }
  }
  //mazn
  for(int i=0;i<mapa->sirka;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska-1;j++)
    {
      if( a1[i][j]){ a[i][j]=1;continue;}
        a[i][j]=stihleni1(a1[i][j-1],a1[i][j],a1[i][j+1]);
    }
  }

  for(int l=0;l<mapa->sirka;l++)
  {
    memcpy(&a1[l][0],&a[l][0],mapa->vyska*sizeof(a[0][0]));
  }
  //thlen zprava
  for(int i=0;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(j=0;j<mapa->vyska;j++)
    {
      if( a1[i][j]){ a[i][j]=1;continue;}
        a[i][j]=stihleni(a1[i+1][j],a1[i][j]);
    }
  }
  //mazn
  for(int i=0;i<mapa->sirka;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska-1;j++)
    {
      if( a[i][j]){ a1[i][j]=1;continue;}
        a1[i][j]=stihleni1(a[i][j-1],a[i][j],a[i][j+1]);
    }
  }
  //mazn
  for(int i=1;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(j=0;j<mapa->vyska;j++)
    {
      if( a1[i][j]){ a[i][j]=1;continue;}
        a[i][j]=stihleni1(a1[i-1][j],a1[i][j],a1[i+1][j]);
    }
  }
  delete a1;
  Prekreslit();
}
//---------------------------------------------------------------------------
// funkce thlen pouze v jednom smru
void TForm1::stihleni_1()
{
  int i,j;
  bool** a1 =new bool* [mapa->sirka];//alokace pamti
  for(int l=0;l<mapa->sirka;l++)
  {
    a1[l] = new bool [mapa->vyska];
    memcpy(&a1[l][0],&a[l][0],mapa->vyska*sizeof(a[0][0]));
  }
  //thlen okraj
  for(j=1;j<mapa->vyska-1;j++)
  {
//    a[0][j]=stihleni(a1[0][j-1],a1[0][j]);
    a[0][j]=stihleni(a1[0][j-1],a1[0][j]);
//    a[mapa->sirka-1][j]=stihleni(a1[mapa->sirka-1][j+1],a1[mapa->sirka-1][j]);
    a[mapa->sirka-1][j]=stihleni(a1[mapa->sirka-1][j+1],a1[mapa->sirka-1][j]);
  }
  for(i=1;i<mapa->sirka-1;i++)
  {
//    a[i][0]=stihleni(a1[i-1][0],a1[i][0]);
    a[i][0]=stihleni(a1[i-1][0],a1[i][0]);
//    a[i][mapa->vyska-1]=stihleni(a1[i+1][mapa->vyska-1],a1[i][mapa->vyska-1]);
    a[i][mapa->vyska-1]=stihleni(a1[i+1][mapa->vyska-1],a1[i][mapa->vyska-1]);
  }
  ProgressBar1->Max=(mapa->sirka-2)*3;//nastaven progressbaru
  ProgressBar1->Position=0;
  //theln z dan strany
  for(i=1;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska-1;j++)
    {
      if( a1[i][j]) {a[i][j]=1;continue;}
        a[i][j]=stihleni(a1[i+(int)sin(al*M_PI_2)][j+(int)cos(al*M_PI_2)],a1[i][j]);
    }
  }
  //mazn
  for(i=1;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska-1;j++)
    {
      if( a[i][j]) {a1[i][j]=1;continue;}
        a1[i][j]=stihleni1(a[i][j-1],a[i][j],a[i][j+1]);
    }
  }
  //mazn
  for(i=1;i<mapa->sirka-1;i++)
  {
    ProgressBar1->Position++;
    for(j=1;j<mapa->vyska-1;j++)
    {
      if( a1[i][j]) {a[i][j]=1;continue;}
        a[i][j]=stihleni1(a1[i-1][j],a1[i][j],a1[i+1][j]);
    }
  }
  al++;
  delete a1;
  Prekreslit();
}
//---------------------------------------------------------------------------
//funkce thlen z nabdky Filtr pkaz thlen
void __fastcall TForm1::theln11Click(TObject *Sender)
{
  stihleni_1();
}
//---------------------------------------------------------------------------
