//---------------------------------------------------------------------------
//Program Filtr
//Slou k filtraci vkov sloky
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <math.h>
#include <ComCtrls.hpp>
#include <fstream.h>
#include <mem.h>
#include "../funkce/vrmlh.h"
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
  __published:    // IDE-managed Components
  TImage *Image1;
  TSaveDialog *SaveDialog1;
  TButton *Button10;
  TButton *Button12;
  TButton *Button13;
  TProgressBar *ProgressBar1;
  TButton *Button18;
  TOpenDialog *OpenDialog1;
  TButton *Button2;
  TScrollBar *ScrollBar1;
  TScrollBar *ScrollBar2;
  TMainMenu *MainMenu1;
  TMenuItem *Soubor1;
  TMenuItem *Otevt1;
  TMenuItem *Filtr1;
  TMenuItem *Oprava1;
  TMenuItem *thlen1;
  TMenuItem *Uloit1;
  TMenuItem *theln11;
  void __fastcall Button10Click(TObject *Sender);
  void __fastcall Button12Click(TObject *Sender);
  void __fastcall Button13Click(TObject *Sender);
  void __fastcall Button18Click(TObject *Sender);
  void __fastcall Button2Click(TObject *Sender);
  void __fastcall ScrollBar1Change(TObject *Sender);
  void __fastcall ScrollBar2Change(TObject *Sender);
  void __fastcall Otevt1Click(TObject *Sender);
  void __fastcall Oprava1Click(TObject *Sender);
  void __fastcall Uloit1Click(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall thlen1Click(TObject *Sender);
  void __fastcall theln11Click(TObject *Sender);
  private:    // User declarations
  public:     // User declarations
  __fastcall TForm1(TComponent* Owner);
  int al;  // smrovka pi thlen1
  void Prekreslit(void);
  void Format();
  void Oprava();
  void stihleni_auto();
  void stihleni_1();
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
Hmapa *mapa = new Hmapa();
int typ;
int tluste[10]; //pole pro ukldn tloutk ry pi vektorizaci
//deklarace funkc
bool test(int ,int,int,int );
void go(int,int,int,int,int);
void sp1(int[],int,int,int,int,int);
void zaclear(int ,int ,int,int,int ,int);
void obkres(int [],int,int ,int ,int,int);
void clear(int ,int ,int,int);
void sou(int& ,int& ,int );
bool test1(int ,int ,int, int,double ,int );
int testpoc(int,int,int,int);
bool** a;//deklarace ukazatele na pam reprezentuc obraz mapy

class  sour_smer : public Hbod2D //struktura pro ukldn parametru o konci ry
{
  public:
  double smer; //pravdpodobn smr ry
  int spoj;    //slo konce s kterm je tento konec spojen
  int del;     //vzdlenost tchto konc
  int cara;    //slo ry na kter se konec nachz
  int cara1;   //slo ry s kterou je konec spojen
  //metoda pro zjitn bodu v pravdpodobnm smru pokraovn v zadan vzdlenosti
  Hbod2D Trans(float delka){ return Hbod2D(x+sin(smer)*delka,y+cos(smer)*delka);   }
  //definice opertoru pro vstup tt struktuy do souboru
  friend ostream& operator << (ostream& h,const sour_smer& bod){return h<<bod.x<<"\t"<<bod.y<<"\t"<<bod.smer*200/M_PI<<"\t"<<bod.spoj<<"\t"<<bod.del<<"\t"<<bod.cara<<"\t"<<bod.cara1<<endl;       }
};
class konce  //tda pro uloen konc ar a prce s nimi
{
  sour_smer* bodkon ;  //ukazatel na pole konc ar
  int count;   //poet konc
  public:
  Hbod2D operator[] (int k){return bodkon[k];} //opertor indexovn pro pstup k souadnicm jednotlivm koncm
  void Spoj(int i){bodkon[i].spoj=-3; } //metoda pro nastaven konce jako konec na okraji mapy
  float get_smer(int i){return bodkon[i].smer;}//metoda vracejc pravdpodobn smr pokraovn vrstevnice
  sour_smer get_bods(int i){return bodkon[i];}//metoda vrac datovou strukturu konce
  int get_spoj(int i){return bodkon[i].spoj;} //metoda vrac navtn konce
  float get_del(int i){return bodkon[i].del;} //metoda vrac dlku spojen dvou konc
  void Spoj(int i,int j,float delka) //metoda pro nastaven konce jako spojenho
  {
    bodkon[i].spoj=j;
    bodkon[j].spoj=i;
    bodkon[i].del=delka;
    bodkon[j].del=delka;
    bodkon[i].cara1=bodkon[j].cara;
    bodkon[j].cara1=bodkon[i].cara;
  }
  void Spoj_plus(int i,int j,float delka)  //metoda pro nastaven konce jako spojenho
  {                                        //a zrove rozpojen bvalho spojen tchto konc
    if(bodkon[j].spoj>=0) bodkon[bodkon[j].spoj].spoj=-1;
    if(bodkon[i].spoj>=0) bodkon[bodkon[i].spoj].spoj=-1;
    bodkon[i].spoj=j;
    bodkon[j].spoj=i;
    bodkon[i].del=delka;
    bodkon[j].del=delka;
    bodkon[i].cara1=bodkon[j].cara;
    bodkon[j].cara1=bodkon[i].cara;
  }
  Hbod2D get_bod(int b){return bodkon[b];} //metoda vrac souadnice konce
  int get_cout(){return count;} //metoda vrac poet konc v seznamu
  void Alloc(int i){count=0;delete bodkon; bodkon = new sour_smer[i];}//metoda alokuje pam pro uloen konc
  konce(int i){count=0; bodkon = new sour_smer[i];}
  konce(){count=0; }
  //metoda pro uloen parametr konc z datov struktry rozpoznan ry
  void bod(int car,Hcara cara)
  {
    bodkon[count].cara=car;
    bodkon[count].spoj=cara.get_spoj1();
    bodkon[count].Zapis(cara.get_bod(0));
    bodkon[count].smer=cara.get_smer1();
    count++;
    bodkon[count].cara=car;
    bodkon[count].spoj=cara.get_spoj2();
    bodkon[count].Zapis(cara.get_bod(cara.get_pocetbodu()-1));
    bodkon[count].smer=cara.get_smer2();
    count++;
  }
  //metoda pro uloen konce
  void bod(int kx, int ky, double ks, int i,int k,int t)
  {
    bodkon[count].cara=k;
    bodkon[count].spoj=i;
    bodkon[count].Zapis(kx,ky);
    bodkon[count].smer=ks;
    count++;
  }
};
konce konec;
//---------------------------------------------------------------------------
//funkce pro zjitn potu bod v tercov oblasti 5x5 pixel
//jestlie je ernch bod vce ne 12 vrac true jako signl pro zatek vektorizace
//x,y  - souadnice na obrzku
//sirka a vyska jsou rozmry obrzku
bool test(int x,int y,int sirka,int vyska)
{
  if(x<0 || y<0 || x>sirka-5 || y>vyska-5) return false;
  int fa=25;
  for(int j=y;j<y+5;j++)
  {
    for(int i=x;i<x+5;i++)
    {
      fa=fa-a[i][j];
    }
  }
  if(fa>12)return true;
  return false;
}
//---------------------------------------------------------------------------
//hlub test jestli je program na e
//x,y  - souadnice na obrzku
//sirka a vyska jsou rozmry obrzku
//dlka dlka rozpoznan ry
//uhel - smr ry pi vektorizaci
bool test1(int x,int y, int sirka,int vyska,double uhel,int delka)
{
  if(x>sirka-5 || y>vyska-5) return  false;
  if(x<5 || y<5 || x>sirka-10 || y>vyska-10) return test(x,y,sirka,vyska);
  double a1,a2;
  int cho;
  int b[2];
  int fa=-100;
  int starfa;
  //zjitn velikosti oblsti pro test
  int tl=tluste[(delka-1)%10]-2;
  if(delka>20)tl=tluste[(delka-1)%10]-3;
  if(tl<2) tl=2;
  if(delka>10)
  {
    float pru=0; //prmrn tlouka ry
    for(int bl=0;bl<10;bl++)
    {
      pru=pru+tluste[bl];
    }
    pru=pru/10;
    if(pru<4)  //jestlie tlouka ry klesne pod uritou mez
    {          //funkce to vyhodnot jako peruen ry
      typ=0 ;
      return false;
    }
  }
  if(x>sirka-1-tl || y>vyska-1-tl)     tl=4;
  //zjitn tlouky ry podle pomru ernch a blch bod ve zvtujc se oblasti
  do
  {
    starfa=fa;
    tl++;
    fa=tl*tl;
    for(int j=y;j<y+tl;j++)
    {
      for(int i=x;i<x+tl;i++)
      {
        #ifdef _DEBUG    //ladc funkce
        if(i<0 || j<0 || i>sirka-1 || j>vyska-1)
          ShowMessage(" Jsi mimo" );
         #endif
        fa=fa-a[i][j];
      }
    }
  }
  while(fa-tl>starfa  &&   x<sirka-tl-2 && y<vyska-tl-2 && tl<13);
  tl--; //zjitn tlouka ry
  tluste[delka%10]=tl;

  if(x<tl+1 || y<tl+1 || x>sirka-2*tl-3 || y>vyska-2*tl-3) return test(x,y,sirka,vyska);
  //test raf - testuje jestli  na obou okrajch ry nejsou ern body neboli vtven ry
  if(starfa>tl*2.5 || (delka>50 && starfa>tl*1.6) || (delka>150 && starfa>tl*1.3))
  {
    if(uhel==20)return true;
    for(int i=0;i<2;i++)
      b[i]=2*tl;
    a1= cos(uhel);
    a2=sin(uhel);
    for(int i=tl/2+1;i<tl/2+1+tl;i++)
    {
       #ifdef _DEBUG    //ladc funkce
      if( (int)(i*a1+x+tl/2)<0 ||  (int)(i*a1+x+tl/2)>sirka-1)   ShowMessage(" x1" );
      if((int)( -i*a2+y+tl/2)<0 ||(int)( -i*a2+y+tl/2)>vyska-1)  ShowMessage(" y1" );//y
        #endif
        b[0]=b[0]-a[(int)(i*a1+x+tl/2)][(int)(-i*a2+y+tl/2)]; // vlevo
       #ifdef _DEBUG
      if((int)(a2+i*a1+x+tl/2)<0||(int)(a2+i*a1+x+tl/2)>sirka-1) ShowMessage(" x2" );//x
        if((int)(a1-i*a2+y+tl/2)<0 || (int)(a1-i*a2+y+tl/2)>vyska-1)ShowMessage(" y2" );//y
        #endif
        b[0]=b[0]-a[(int)(a2+i*a1+x+tl/2)][(int)(a1-i*a2+y+tl/2)];
       #ifdef _DEBUG
      if((int)(-i*a1+x+tl/2+1)<0||(int)(-i*a1+x+tl/2+1)>sirka-1) ShowMessage(" x3" );//x
        if((int)(i*a2+y+tl/2+1)<0 || (int)(i*a2+y+tl/2+1)>vyska-1)ShowMessage(" y3" );//y
        #endif
        b[1]=b[1]-a[(int)(-i*a1+x+tl/2+1)][(int)(i*a2+y+tl/2+1)];
       #ifdef _DEBUG
      if((int)(a2-i*a1+x+tl/2+1)<0||(int)(a2-i*a1+x+tl/2+1)>sirka-1) ShowMessage(" x4" );//x
        if((int)(a1+i*a2+y+tl/2+1)<0 || (int)(a1+i*a2+y+tl/2+1)>vyska-1)ShowMessage(" y4" );//y
        #endif
        b[1]=b[1]-a[(int)(a2-i*a1+x+tl/2+1)][(int)(a1+i*a2+y+tl/2+1)];
    }
    if(b[0]<5 && b[1]<5) return true;
    if( b[0]+b[1]<10 && delka >30)   return true;
    if( b[0]+b[1]<12 && delka >100)   return true;
    else
    {
      typ=2;
      return false;
    }
  }
  typ=1;
  return false;
}
//---------------------------------------------------------------------------
//funkce pro zjitn nejpravdpodobnjho smru postupu pi vektorizaci
//dt promnn pro ukldn potu ernch bod v jednotlivch smrech monho postupu
//sirka a vyska jsou rozmry obrzku
//dlka dlka rozpoznan ry
//x,y  - souadnice na obrzku
void sp1(int dt[4],int x,int y,int sirka,int vyska,int delka)
{
  int starfa,fa=-100,tl;
  tl= tluste[abs((delka-1)%10)]-2 ;
  if(x>sirka-1-tl || y>vyska-1-tl)     tl=4;
  //zjitn tloutky ry
  do
  {
    starfa=fa;
    tl++;
    fa=tl*tl;
    for(int j=y;j<y+tl;j++)
    {
      for(int i=x;i<x+tl;i++)
      {
        #ifdef _DEBUG    //ladc funkce
        if(i<0 || j<0 || i>sirka-1 || j>vyska-1)
          ShowMessage(" Jsi mimo" );
        #endif
        fa=fa-a[i][j];
      }
    }
  }
  while(fa-tl>starfa  &&   x<sirka-tl-2 && y<vyska-tl-2 && tl<20 );
  tl--;
  int b;
  //vpoet potu ernch bod v jednotlivch smrech postupu
  dt[0]=100;
  dt[2]=100;
  dt[1]=100;
  dt[3]=100;
  for(int h=0;h<5;h++)
  {
    dt[1]=dt[1]+a[x+h][y];
    dt[3]=dt[3]+a[x][y+h];
  }
  if(dt[1]>104 || dt[3]>104)
    return;
  
  dt[0]=100;
  dt[1]=100;
  dt[2]=100;
  dt[3]=100;
  if(x>1 && y>1 && x<sirka-tl-2 && y<vyska-tl-2)
  {
    for(int l=-1;l<tl+2;l++)
    {
      dt[0]=dt[0]-a[x+l][y-1];
      dt[1]=dt[1]-a[x+l][y+tl];
      dt[2]=dt[2]-a[x-1][y+l];
      dt[3]=dt[3]-a[x+tl][y+l];
    }
  }
  if(x>sirka-tl)
    tl=sirka-1-x;
  if (y>vyska-tl)
    tl=vyska-1-y;
  for(int l=0;l<tl+1;l++)
  {
    dt[0]=dt[0]-a[x+l][y];
    dt[1]=dt[1]-a[x+l][y+tl-1];
    dt[2]=dt[2]-a[x][y+l];
    #ifdef _DEBUG    //ladc funkce
    if( x+tl-1>sirka-1 || y+l>vyska-1 ||x+tl-1<0 || y+l<0)
      ShowMessage("Tady");
    #endif
    dt[3]=dt[3]-a[x+tl-1][y+l];
  }
  return ;
}
//---------------------------------------------------------------------------
//funkce pevd smr na posun souadnic
//po zakdovan smr posunu 1-nahoru 2-doleva 3-dolu 4-doprava
//x,z souadnice pro posun
void sou(int& x,int& y,int po)
{
  switch(po)
  {
    case 1: y--;
      break;
    case 2: x--;
      break;
    case 3: y++;
      break;
    case 4: x++;
    }
}
//---------------------------------------------------------------------------
//funkce pro uloen zvektorizovan ry do pamti
//a posloupnost posun po e
//x,y poten bod ry
//poc poet posun v posloupnosti a
//sirka, vyska rozmry obrzku
void obkres(int a[1000],int x,int y,int poc,int sirka,int vyska)
{
  if(poc>20 ||(typ==2 && poc>40)) //jestli dlka ry pekro danou mez ulo ru
  {
    for(int he=0;he<5;he++)    //smae kus zacatku
    {
      sou(x,y,a[he]);
    }
    int sx=x,sy=y;
    int sx1,sy1,sx2,sy2;
    ;
    double prum;        //pro uhel
    mapa->Novacara();//vytvoen nov ry
    mapa->Pridej_bod_na_posledni_caru(x,y); //pidn bodu na ru
    sx2=x;
    sy2=y;
    //uloen ry
    for(int he=5;he<poc-5;he++)
    {
      if(he==20 || (poc-6<20 && he==poc-6))
      {
        prum=atan2(-x+sx,-y+sy) ;
        if(prum<0)prum=prum+M_PI*2 ;
        if(sx>6 && sy>6 && sx<sirka-12 && sy<vyska-12)
        {
          int px=sx+sin(prum)*50.0;
          int py=sy+cos(prum)*50.0;
          if(px>6 && py>6 && px<sirka-12 && py<vyska-12)
            mapa->set_konec1_na_posledni_caru(prum,-1);
          else      mapa->set_konec1_na_posledni_caru(prum,-3);//nastav e konec ry je na okraji mapy
        }
        else      mapa->set_konec1_na_posledni_caru(prum,-3);
      }
      if((he-5)%15==0)
      {
        mapa->Pridej_bod_na_posledni_caru(x,y); //pid bod na ru
        sx1=x;
        sy1=y;
      }
      if(he==poc-20)
      {
        sx2=x;
        sy2=y;
      }
      sou(x,y,a[he]);
    }
    if(sx1!=x || sy1!=y)  mapa->Pridej_bod_na_posledni_caru(x,y);
    prum=atan2(x-sx2,y-sy2) ;
    if(prum<0)prum=prum+M_PI*2 ;
    if(x>6 && y>6 && x<sirka-12 && y<vyska-12)
    {
      int px=x+sin(prum)*50.0;
      int py=y+cos(prum)*50.0;
      if(px>6 && py>6 && px<sirka-12 && py<vyska-12)
        mapa->set_konec2_na_posledni_caru(prum,-1);
      else  mapa->set_konec2_na_posledni_caru(prum,-3);  //nastav e konec ry je na okraji mapy
    }
    else      mapa->set_konec2_na_posledni_caru(prum,-3);
  }
}
//---------------------------------------------------------------------------
//funkce mae ern body po zvektorizovan e na konci vektorizace 1 ry
//x,y  - souadnice na obrzku, kde se aktuln nacht vektorizace
//sirka, vyska rozmry obrzku
void clear(int x,int y,int sirka,int vyska)
{
  int py=5,px=5;
  if(x<0)x=0;
  if(y<0)y=0;
  if(x>sirka-px)px=sirka-x;
  if(y>vyska-py)py=vyska-y;
  //nastavuje danou oblast na bl body
  for(int j=y;j<y+py-1;j++)
  {
    for(int i=x;i<x+px-1;i++)
    {
      a[i][j]=1;
    }
  }
}
//---------------------------------------------------------------------------
//funkce mae ern body pi vektorizaci ry, aby se vektorizan proces nemohl vrtit
//do msta zatku vektorizace ry
//x,y  - souadnice na obrzku, kde se aktuln nacht vektorizace
//sirka, vyska rozmry obrzku
//t - smr ve kterm se maj mazat ern body
//dlka ry
void zaclear(int x,int y,int t,int sirka,int vyska,int delka)
{
  //nastaven oblasti mazn
  int tll=tluste[(delka-1)%10];
  int tl1x=tll,tl2x=tll;
  int tl1y=tll,tl2y=tll;
  if(x<tll)tl1x=x;
  if(x>sirka-tll)tl2x=sirka-x;
  if(y<tll)tl1y=y;
  if(y>vyska-tll)tl2y=vyska-y;
  //vlastn mazn ve smru t
  switch(t)
  {
    case 1:
      for(int d=x-tl1x;d<x+tl2x;d++)a[d][y+4]=1;
      break;
    case 2:
      for(int d=y-tl1y;d<y+tl2y;d++) a[x+4][d]=1;
      break;
    case 3:
      for(int d=x-tl1x;d<x+tl2x;d++)a[d][y]=1;
      break;
    case 4:
      for(int d=y-tl1y;d<y+tl2y;d++)a[x][d]=1;
      break;
  }
}
//---------------------------------------------------------------------------
//vektorizan funkce
//x,y potek odkud se m zat ra vektorizovat
//ne smr ve kterm ra nesm pokraovat(smr odkud ra pichz)
//sirka, vyska rozmry obrzku
void go(int x,int y,int ne,int sirka,int vyska)
{
  int ares[4]; //pole pro uloen potu ernch bod v jednotliv smrech
  int a1,a2,a3;  //promnn pro uloen potu ernch bod v relevantnch smrech
  int a[2000];  //pole pro uloen smr posun vektorizace
  int stax=x;  //promnn pro uloen potenho bodu vektorizace
  int stay=y;
  int sta=0;   //poet hodnot v poli a (dka ry)
  int sdo=0;   //pedminul smr vektorizace, kterm nesm jt vektorizace
  int sx,sy;   //pomocn souadnice
  for(int i=0;i<10;i++)     tluste[i]=5;//nastaven tlouky
  double    prum;  //smr pravdpodobnho pokraovn vektorizace
  do
  { //zjitn smru postupu
    switch (ne)  //zamezen vektorizace v minulm smru
    {
      case 1:
        sp1(ares,x,y,sirka,vyska,sta);//zjitn potu ernch bod v jednotlivch smrech
        a1=ares[2];  //pevod smr
        a2=ares[0];
        a3=ares[3];
        if(sdo== 4)a1=0; //zamezen vektorizace v pedminulm smru
        else if(sdo==3)a[1]=0;
        else if(sdo==2)a[2]=0;
        if(a1>=a2 && a1>=a3) //zjitn smru posunu
        {
          zaclear(x,y,2,sirka,vyska,sta);   //smazn ernch bod za vektoizan funkc
          x=x-1;//posun
          ne=2; //uloen smru ve kterm nesm vektorizace pokraovat
          break;     
        }
        if(a2>=a3 && a2>=a1) //  et cetera et cetera
        {
          zaclear(x,y,1,sirka,vyska,sta);
          y=y-1;
          ne=1;
          break;
        }
        if(a3>=a1 && a3>=a2)
        {
          zaclear(x,y,4,sirka,vyska,sta);
          x=x+1;
          ne=4;
          break;
        }
        case 2:
        sp1(ares,x,y,sirka,vyska,sta);
        a1=ares[1];
        a2=ares[2];
        a3=ares[0];
        if(sdo== 1)a1=0;
        else if(sdo==4)a2=0;
        else if(sdo==3)a3=0;
        if(a1>=a2 && a1>=a3)
        {
          zaclear(x,y,3,sirka,vyska,sta);
          y=y+1;
          ne=3;
          break;
        }
        if(a2>=a3 && a2>=a1)
        {
          zaclear(x,y,2,sirka,vyska,sta);
          x=x-1;
          ne=2;
          break;
        }
        if(a3>=a1 && a3>=a2)
        {
          zaclear(x,y,1,sirka,vyska,sta);
          y=y-1;
          ne=1;
          break;
        }
        case 3:
        sp1(ares,x,y,sirka,vyska,sta);
        a1=ares[2];
        a2=ares[3];
        a3=ares[1];
        if(sdo== 4)a1=0;
        else if(sdo==2)a2=0;
        else if(sdo==1)a3=0;
        if(a1>=a2 && a1>=a3)
        {
          zaclear(x,y,2,sirka,vyska,sta);
          x=x-1;
          ne=2;
          break;
        }
        if(a2>=a3 && a2>=a1)
        {
          zaclear(x,y,4,sirka,vyska,sta);
          x=x+1;
          ne=4;
          break;
        }
        if(a3>=a1 && a3>=a2)
        {
          zaclear(x,y,3,sirka,vyska,sta);
          y=y+1;
          ne=3;
          break;
        }
        case 4:
        sp1(ares,x,y,sirka,vyska,sta);
        a1=ares[0];
        a2=ares[3];
        a3=ares[1];
        if(sdo== 3)a1=0;
        else if(sdo==2)a2=0;
        else if(sdo==1)a3=0;
        if(a1>=a2 && a1>=a3)
        {
          zaclear(x,y,1,sirka,vyska,sta);
          y=y-1;
          ne=1;
          break;
        }
        if(a2>=a3 && a2>=a1)
        {
          zaclear(x,y,4,sirka,vyska,sta);
          x=x+1;
          ne=4;
          break;
        }
        if(a3>=a1 && a3>=a2)
        {
          zaclear(x,y,3,sirka,vyska,sta);
          y=y+1;
          ne=3;
          break;
        }
      }
    a[sta]=ne;
    sta++;
    if(sta>1)sdo=a[sta-2];
    if(sta>1990)
    {
      obkres(a,stax,stay,sta,sirka,vyska);
      clear( x, y,sirka,vyska);
      return;
    }
    if(sta>5)
    {
      sx=x;
      sy=y;
      for(int he=sta-5;he<sta;he++)
      {
        sou(sx,sy,a[he]);
      }
      if(y-sy==0)prum =M_PI/2;
      else prum=atan2(x-sx,y-sy) ;
      if(prum<0)prum=prum+M_PI;
    }
    if (test1(x,y,sirka,vyska,sta>5?prum:20.0,sta)==false)//test vtven ry
    {                                                     //nebo konce ry
      obkres(a,stax,stay,sta,sirka,vyska); //uloen ry
      clear( x, y,sirka,vyska); //smazn zbytku ry
      return;
    }
  }
  while(x>=0 && y>=0 && x<sirka-4 && y<vyska-4); //vektorizuj ru dokud se nenaraz na okraj mapy
  typ = 3;
  obkres(a,stax,stay,sta,sirka,vyska); //uloen ry
  clear( x, y,sirka,vyska); //smazn zbytku ry
}
//---------------------------------------------------------------------------
//funkce pro stihleni - mazn okraje ry
//a,b hodnoty jednotlivch pixlel
inline bool stihleni(bool a,bool b)
{
  if(a && !b)
  {
    return true;
  }
  return b;
}
//---------------------------------------------------------------------------
//pomocn funkce pro mazn ry tlust 1 bod
//a,b,c hodnoty jednotlivch pixlel
inline bool stihleni1(bool a,bool b,bool c)
{
  if(a && !b && c)
  {
    return true;
  }
  return b;
}
//---------------------------------------------------------------------------
//funkce, kter vrac poet ernch bod v dan oblasti 5x5 bod
//x,y souadnice msta testu
//sirka, vyska rozmry obrazku
int testpoc(int x,int y,int sirka,int vyska)
{
  if(x<0 || y<0 || x>sirka-5 || y>vyska-5) return false;
  int fa=50;
  for(int j=y;j<y+5;j++)
  {
    for(int i=x;i<x+5;i++)
    {
      fa=fa-a[i][j];
    }
  }
  return fa;
}
//---------------------------------------------------------------------------
#endif
